import java.rmi.*;
import java.util.*;

public class BankClient 
{
    static IBankServer bank;
    private String url;
    private String name;
    private String passwort;
    
    public BankClient(String url, String name, String passwort)
    {
        this.url = url;
        this.name = name;
        this.passwort = passwort;
    }
    
    public void verbinden()
    {
        try {
            bank = (IBankServer) Naming.lookup("rmi://192.168.2.93/OnlineBank");
        } catch (Exception e) 
          {
    	    System.out.println("Fehler ist" +  e);
    	  }
    }
    
    public void eroeffnen()
    {
        try {
            String nachricht =  bank.eroeffneKonto(name,passwort);
            System.out.println(nachricht);
        } catch (RemoteException e) {
    	    System.out.println(e); 
    	}
    }

    public void schliessen()
    {
       try { 
           int betrag = bank.loeschKonto(name, passwort);
           System.out.println("Konto geloescht. Sie erhalten " + betrag + " Euro zurck");
        } catch (RemoteException e) {
    	    System.out.println(e); 
    	}
   }
   
   public void einzahlen(int betrag)
   {        
        try {
    		   bank.einzahlen(name,passwort,betrag);
        	   System.out.println("Betrag eingezahlt");
    	 } catch (RemoteException e) {
    	    System.out.println(e); 
    	}
	}

    public void abheben(int betrag)
    {   
        try {
        		bank.abheben(name,passwort,betrag);
        		System.out.println("Sie erhalten " + betrag + " Euro");
		 } catch (RemoteException e) {
    	    System.out.println(e); 
    	}
    }	
    
    public void kontostand()
    {
       try {
           int betrag = bank.kontostand(name,passwort);
           System.out.println("Ihr Kontostand betraegt " + betrag + " Euro");
        } catch (RemoteException e) {
    	    System.out.println(e); 
    	}
    }	
    
    public void kontoauszug()
    {
        try {
    		Vector auszug = bank.kontoauszug(name,passwort);
    		for (int i=0; i< auszug.size(); i++) 
    		{
    		    System.out.println(auszug.elementAt(i));
            }
         } catch (RemoteException e) {
    	    System.out.println(e); 
    	}
     }
}	
	    





