import java.rmi.*;
import java.rmi.server.*;
import java.util.*;

public class BankServer extends UnicastRemoteObject implements IBankServer 
{
    private Hashtable konten = new Hashtable();
    private String fehler = "Konto existiert nicht oder falsches Passwort";
    private Konto privat;

    public BankServer() throws RemoteException 
    {
    	super();
    }
    
    //prft ob das Konto existiert und das Passwort korrekt ist
    private boolean pruef(String name, String passwort) 
    {
    	privat = (Konto) konten.get(name);
    	if (( privat != null ) && ( privat.authentisierung(passwort)))
           	return true;
    	else 
        	return false;
    }

    //Ein Konto mit dem angegebenen Namen und Passwort erffnen
    public synchronized String eroeffneKonto(String name, String passwort) throws RemoteException 
    {
    	if (konten.get(name) == null ) 
    	{
    	    privat = new Konto(passwort);
    	    konten.put(name,privat);
    	    return("Konto erffnet");
    	}
    	else
    	    return("Es gibt bereits ein Konto auf den Namen" + name);
    }

    //angegebenes Konto loeschen
    public synchronized int loeschKonto(String name, String passwort) throws RemoteException 
    {
    	System.out.println("Konto loeschen");
    	int betrag;
    	if ( pruef(name,passwort)) 
    	{
    	    privat = (Konto) konten.get(name);
    	    betrag = privat.getKontostand();
    	    System.out.println(betrag);
    	    konten.remove(name);
    	}
    	else
    	    betrag = 0;
    	return betrag;
    }

    //Geld auf das Konto einzahlen
    public String einzahlen(String name, String passwort, int betrag) throws RemoteException 
    {
    	String nachricht;
    	if ( pruef(name,passwort)) 
    	{
    	    privat = (Konto) konten.get(name);
    	    privat.einzahlen(betrag);
    	    nachricht= "Betrag eingezahlt";
            }
         else
    	    nachricht=fehler;
    	return nachricht;
    }

    //Den angegebenen Betrag vom Konto abheben
    public String abheben(String name, String passwort, int betrag) throws RemoteException 
    {
    	String nachricht;
    	if ( pruef(name,passwort)) 
    	{
    	    privat = (Konto) konten.get(name);
    	    privat.abheben(betrag);
    	    nachricht="Betrag abgehoben";
    	}
    	else
    	    nachricht=fehler;
    	return nachricht;
    }

    //Kontostand abfragen
    public int kontostand(String name, String passwort) throws RemoteException 
    {
    	int betrag;
    	if ( pruef(name,passwort)) 
    	{
    	    privat = (Konto) konten.get(name);
    	    betrag = privat.getKontostand();
    	}
    	else 
    	{
    	    betrag = -1;
    	}
    	return betrag;
    }

    //Kontoauszug als String-Vector
    public Vector kontoauszug(String name, String passwort) throws RemoteException 
    {
    	Vector auszug;
    	if ( pruef(name,passwort)) 
    	{
    	    privat = (Konto) konten.get(name);
    	    auszug = privat.getKontoauszug();
    	}
    	else 
    	{
    	    auszug = new Vector();
    	    auszug.addElement(fehler);
    	}
    	return auszug;
    }

    public static void main(String[]args) 
    {
    	try {
    	    BankServer bank = new BankServer();
    	    Naming.rebind("OnlineBank",bank);
    	} catch (Exception e) {
    	    e.printStackTrace();
    	}
    }
}































