//Barbara Leipholz-Schumacher
//1.4.2003

import java.rmi.*;
import java.rmi.server.*;

public class ChatClient extends UnicastRemoteObject implements IChatClient 
{
  private ChatFenster fenster;
  private String name;
  private IChatServer server;
  private String serverName;

  public ChatClient(String name, String serverName) throws RemoteException 
  {
    this.name = name;
    this.serverName = serverName;
    //GUI erzeugen
    fenster = new ChatFenster(this);
    //sendet Texteingaben zum Server
    //nach dem Schliessen des Fensters wird trennen() aufgerufen
    //Verbindung zum Server herstellen
    verbinden();
  }

  public void verbinden() 
  {
    try {
          server = (IChatServer) Naming.lookup("rmi://"+ serverName + "/ChatServer");
          server.anmelden(name, this);
    } catch (Exception ausnahme) {
            ausnahme.printStackTrace();
    }
   }

   public void trennen() {
     try {
           server.abmelden(name);
    } catch (Exception ausnahme) {
            ausnahme.printStackTrace();
    }
   }
   
  public void zumServerSenden(String nachricht) 
  {
      try {
         server.anAlleSenden(name, nachricht);
      } catch (RemoteException fehler)  {
            fehler.printStackTrace();
      }    
  }
 
  public void ausgeben(String name, String nachricht) 
  {
     fenster.schreib(name + " : " + nachricht);
  }

  public static void main(String[] args) 
  {
     try {
       //Aufruf mit Benutzername Serveradresse
       new ChatClient(args[0],args[1]);
     } catch (Exception ausnahme) {
            ausnahme.printStackTrace();
     }
   }
}









