//Barbara Leipholz-Schumacher
//1.4.2003

import java.rmi.*;
import java.rmi.server.*;
import java.util.*;

public class ChatServer extends UnicastRemoteObject implements IChatServer 
{
  private Hashtable chatter;
  private IChatClient client;

  public ChatServer() throws RemoteException 
  {
      chatter = new Hashtable();
  }

/**
 * Fgt einen neuen Client zur Hashtabelle hinzu und
 * und sendet allen Clients die entsprechende Nachricht zur Anzeige im Chat-Fenster
*/
  public synchronized void anmelden(String name, IChatClient neuerClient) throws RemoteException 
  {
    chatter.put(name, neuerClient);
    //Betreten des Chats allen anderen bekannt geben
    String nachricht = "hat Chat betreten";
    anAlleSenden(name,nachricht);
    //Kontrollmeldung
    System.out.println("Neues Mitglied " + name + " hat Chat betreten");
   }

/**
 * Entfernt den Client aus der Hashtabelle und 
 * sendet allen Clients die entsprechende Nachricht, zur Anzeige im Chat-Fenster
*/
  public synchronized void abmelden(String name) throws RemoteException 
  {
    chatter.remove(name);
    String nachricht = "hat Chat verlassen";
    //Verlassen des Chats allen anderen bekannt geben
    anAlleSenden(name,nachricht);
    //Kontrollmeldung
    System.out.println(name + " hat Chat verlassen");
  }

/**
 * Sendet eine Nachricht an alle Clients, zur Anzeige im Chat-Fenster
*/
  public synchronized void anAlleSenden(String name, String nachricht) throws RemoteException 
  {
    Enumeration aufzaehlung = chatter.elements();
    while (aufzaehlung.hasMoreElements()) 
    {
       client = (IChatClient) aufzaehlung.nextElement();
       client.ausgeben(name,nachricht);
    }
}

  public static void main(String args[]) 
  {
    try {
      ChatServer server = new ChatServer();
      Naming.rebind("ChatServer",server);
    } catch (Exception ausnahme) {
      ausnahme.printStackTrace();
    }
   }
}


