//Barbara Leipholz-Schumacher, 14.9.2001

import java.io.*; 
import java.net.*; 

public class EchoClient {

    private static Socket echoSocket;
    private static PrintWriter zumServer;
    private static BufferedReader vomServer;
    private String serverName;
    private int port;
    
    public EchoClient(String serverName,int port)
    {
        this.serverName = serverName;
        this.port = port;
        //Verbindungswunsch an den Server "ada" an Port 1100 
        //TCP-Socketobjekt zur Kommunikation ber das Netz erzeugen  
        try {
            echoSocket = new Socket(serverName,port);
            //Objekt zum Versenden von Nachrichten ber den Socket erzeugen 
            zumServer = new PrintWriter(echoSocket.getOutputStream(), true); 
            //Objekt zum Empfangen von Nachrichten ber das Socketobjekt erzeugen 
            vomServer = new BufferedReader(new InputStreamReader(echoSocket.getInputStream()));
            kommunikation();
        } catch ( IOException e) { 
            System.out.println("Socket-Fehler!");
        }
    }

    private static void kommunikation() 
    {
        try {
            //Objekt zum Lesen der Tastatureingabe
            BufferedReader ein = new BufferedReader(new InputStreamReader(System.in)); 
            //Nachricht vom Server ber das Socketobjekt lesen 
            String nachricht = vomServer.readLine(); 
            //Nachricht auf dem Bildschirm ausgeben 
            System.out.println(nachricht);
            String eingabe = ein.readLine();
            //Solange der Benutzer beliebigen Text und nicht "bye" ber die Tastatur eingibt 
            while (!eingabe.equals("bye") && (nachricht != null)) { 
            //Tastatureingabe zum Server senden 
            zumServer.println(eingabe); 
            //Antwort vom Server lesen 
            nachricht = vomServer.readLine(); 
            //Nachricht vom Server auf dem Bildschirm ausgeben 
            System.out.println(nachricht);
            eingabe = ein.readLine();
            }
            echoSocket.close();
        } catch (IOException io) {
            System.out.println("IO-Fehler");
        } 
    }

  
    public static void main(String[] args) throws IOException { 
        //Name des Servers, es kann auch die IP-Adresse angegeben werden
        String serverName = "192.168.0.91";
        //port des Servers ber den die Kommunikation geht
        int port = 1100;
        new EchoClient(serverName,port);
    }   
}












